

#include <iostream>
#include <string>
using namespace std;


#include "DensityMap.h"
#include "SegRegions.h"




int main (int argc, char * const argv[])
{
    // insert code here...
    std::cout << "params:\n";

	for ( int i=0; i < argc; i++ ) {
		string p = argv[i];
		printf ("- %d [%s]\n", i, p.c_str());
	}
	printf("\n");

	printf("seg <map> <thr>\n\n");
	if ( argc != 3 ) return 0;

	DensityMap *dmap = new DensityMap;
	dmap->ReadMRC ( argv[1] );

	printf ( "Read %s, %d %d %d\n", dmap->name.c_str(), dmap->n[0], dmap->n[1], dmap->n[2] );


	//dmap->Normalize(); 
	//dmap->WriteMRC ( (dmap->name + "_inv").c_str() );
	
	
	float threshold; sscanf ( argv[2], "%f", &threshold );

	Regions *regs = dmap->Watershed ( (double) threshold );
	regs->Compute_COMs_bRads();

	char regs_fname[100];
	sprintf (regs_fname, "%s_D%.3f_regions", dmap->name.c_str(), threshold );
	regs->Write ( regs_fname );

    return 0;
}




/*
	if ( nsteps > 0 )
	printf ( "\n%d steps, step size %.4f, aiming for %d regions\n\n", nsteps, step_size, targNRegions );

	if ( nsteps <= 0 || step_size <= 0 ) {
		printf (" - need positve number of steps and step size\n\n" );
		return 1;
	}

	char gname[100];
	string init_dmap_name = dmap->name;

	for ( int i=0; i < nsteps; i++ )
	{
		printf ("_____________ step %d _____________\n\n", i+1);

		float sm_size = step_size*(float)(i+1);
		sprintf ( gname, "%s_gs%.0f.mrc", init_dmap_name.c_str(), sm_size );
		dmap->ReadMRC ( gname );

		float nthreshold = (float) dmap->RegionsThreshold ( regs );
		printf ( "\nRegions threshold: %.4f\n", nthreshold );

		Regions *smooth_regs = dmap->Watershed ( nthreshold );
		smooth_regs->Compute_COMs_bRads();

		Regions *nregs = regs->GroupByOverlap ( *smooth_regs );

		sprintf (regs_fname, "%s_gs%.0f_D%.2f_regions", init_dmap_name.c_str(), sm_size, nthreshold );
		nregs->Write ( regs_fname );
		printf ( "\n" );

		regs->Clear();
		// delete regs;
		regs = nregs;

		if ( regs->mRegs.size() <= targNRegions ) {
			printf ("Reached target # of regions!\n");
			break;
		}
	}
*/


